#ifndef _NETDONGLEARM_H_
#define _NETDONGLEARM_H_


#include "windows.h"

#ifdef __cplusplus
extern "C" {
#endif

//ľ
typedef void*   DONGLE_HANDLE;

//x  y ģ
#define MAKEDWORD(x,y)((DWORD)(((DWORD)(x)<<16)&0xFFFF0000)|(DWORD)(((DWORD)(y)&0x0000FFFF)))
		
//
#define   DONGLE_SUCCESS                       0x00000000          // ɹ
#define   DONGLE_NOT_FOUND                     0xF0000001          // δҵָ豸
#define   DONGLE_INVALID_HANDLE				   0xF0000002		   // Чľ
#define   DONGLE_INVALID_PARAMETER			   0xF0000003		   // 
#define   DONGLE_COMM_ERROR					   0xF0000004		   // ͨѶ
#define   DONGLE_INSUFFICIENT_BUFFER		   0xF0000005		   // ռ䲻
#define   DONGLE_NOT_INITIALIZED               0xF0000006		   // Ʒδʼ (ûPID)
#define   DONGLE_ALREADY_INITIALIZED		   0xF0000007		   // ƷѾʼ (PID)
#define   DONGLE_ADMINPIN_NOT_CHECK			   0xF0000008		   // û֤
#define   DONGLE_USERPIN_NOT_CHECK			   0xF0000009		   // ûû֤
#define   DONGLE_INCORRECT_PIN				   0xF000FF00		   // 벻ȷ (2λָʾʣ)
#define   DONGLE_PIN_BLOCKED				   0xF000000A		   // PIN
#define   DONGLE_ACCESS_DENIED				   0xF000000B		   // ʱܾ 
#define   DONGLE_FILE_EXIST					   0xF000000E		   // ļѴ
#define   DONGLE_FILE_NOT_FOUND				   0xF000000F		   // δҵָļ
#define	  DONGLE_READ_ERROR                    0xF0000010          // ȡݴ
#define	  DONGLE_WRITE_ERROR                   0xF0000011          // дݴ
#define	  DONGLE_FILE_CREATE_ERROR             0xF0000012          // ļ
#define	  DONGLE_FILE_READ_ERROR               0xF0000013          // ȡļ
#define	  DONGLE_FILE_WRITE_ERROR              0xF0000014          // дļ
#define	  DONGLE_FILE_DEL_ERROR                0xF0000015          // ɾļ
#define   DONGLE_FAILED                        0xF0000016          // ʧ
#define   DONGLE_CLOCK_EXPIRE                  0xF0000017          // ʱӵ
#define   DONGLE_ERROR_UNKNOWN		           0xFFFFFFFF		   // δ֪Ĵ

//ز
#define	  DONGLE_FAILED_NET_CONNECTED		   0xF0000018			//Ѿ
#define   DONGLE_FAILED_NET_FULL			   0xF0000019			//
#define	  DONGLE_FAILED_NET_NOTFINDNETLOCK	   0xF0000020			//ûҵõ
#define	  DONGLE_FAILED_NET_NOCONNECTED		   0xF0000021			//ûн
#define	  DONGLE_FAILED_NET_DELETED			   0xF0000022			//ͻѾϿ
#define	  DONGLE_FAILED_NET_DENIED			   0xF0000023			//ͻܾʷ

//ͨѶֵ
#define   R_CONNECTFAILED					   0xC0000001	        //ʧ
#define   R_SENDDATAFAILED					   0xC0000002	        //ʧ
#define   R_SENDDATATIMEOUT					   0xC0000003	        //ݳʱ
#define   R_CREATESOCKETFAILED				   0xC0000004	        //׽ʧ
#define   R_RECVDATATIMEOUT					   0xC0000005	        //ݳʱ
#define   R_RECVDATAERROR					   0xC0000006	        //ݴ

//ʱĬϵUSERPIN
#define CONST_USERPIN              "12345678"


#define LED_OFF			           0 //
#define LED_ON			           1 //
#define LED_BLINK		           2 //

//ļͶ
#define FILE_DATA                  1 //ͨļ
#define FILE_PRIKEY_RSA            2 //RSA˽Կļ
#define FILE_PRIKEY_ECCSM2         3 //ECCSM2˽Կļ(SM2˽ԿļECC˽Կļṹͬͬļ)
#define FILE_KEY                   4 //SM43DESԿļ
#define FILE_EXE                   5 //ִļ


#define FLAG_ENCODE                0 //
#define FLAG_DECODE                1 //

/**   
 *   ļ˵
 *   1.RSA˽ԿļΪ8
 *   2.ECCSM2˽ԿļΪ16
 *   3.3DES/SM4ԿļΪ32
 *   4.ִļΪ64,ܴСܳ64K
 *   5.ļڿռСļϵͳصӰ죬ļ54    
 *   6.ļIDȡֵΧΪ0x0000~0xFFFF֮䣬ID0x00000xFFFF0x3F00ϵͳռãûʹá
 */


//RSAԿʽ(1024,2048)
typedef struct {
	unsigned int  bits;                   // length in bits of modulus
	unsigned int  modulus;				  // modulus
	unsigned char exponent[256];          // public exponent
} RSA_PUBLIC_KEY;

//RSA˽Կʽ(1024,2048)
typedef struct {
	unsigned int  bits;                   // length in bits of modulus
	unsigned int  modulus;                // modulus
	unsigned char publicExponent[256];    // public exponent
	unsigned char exponent[256];          // private exponent
} RSA_PRIVATE_KEY;

//ⲿECCԿʽ (192,256)
typedef struct{
	unsigned int bits;                    // length in bits of modulus
	unsigned int XCoordinate[8];          // ϵX
	unsigned int YCoordinate[8];          // ϵY
} ECCSM2_PUBLIC_KEY;

//ⲿECC˽Կʽ (192,256)
typedef struct{
	unsigned int bits;                    // length in bits of modulus
	unsigned int PrivateKey[8];           // ˽Կ
} ECCSM2_PRIVATE_KEY;

//Ϣ
typedef struct
{	
	unsigned short  m_Ver;               //COS汾,:0x0201,ʾ2.01 
	unsigned short  m_Type;              //Ʒ: 0xFFʾ׼, 0x00Ϊʱ,0x02Ϊ׼U  
	unsigned char   m_BirthDay[8];       // 
	unsigned long   m_Agent;             //̱,:Ĭϵ0xFFFFFFFF
	unsigned long   m_PID;               //ƷID
	unsigned long   m_UserID;            //ûID
	unsigned char   m_HID[8];            //8ֽڵӲID
	unsigned long   m_IsMother;          //ĸ־: 0x01ʾĸ, 0x00ʾĸ
	unsigned long   m_DevType;           //豸(PROTOCOL_HIDPROTOCOL_CCID)
	
} DONGLE_INFO;

/** 
* @brief  ööٳе
*
* @param  pDongleInfo     [out]     豸Ϣ顣˲ΪNULLʱ, pCountҵ豸Ŀ
* @param  pCount 	      [out]     豸Ŀúͬʱöٳ32HID豸32CCID豸
*
* @return DONGLE_SUCCESS            ִгɹ
*/
DWORD WINAPI Dongle_Enum(DONGLE_INFO * pDongleInfo, int * pCount);

/**
* @brief  ָļָģš
*
* @param  phDongle     [out]     ָ롣򿪳ɹ,ᱻ䡣
* @param  nIndex       [in]      ָļģ иΪΪģ
*
* @return DONGLE_SUCCESS         򿪳ɹ
*/
DWORD WINAPI Dongle_Open(DONGLE_HANDLE * phDongle, int nIndex);

/**
* @brief  رմ򿪵ļ
*
* @param  hDongle     [in]     򿪵ļ
*
* @return DONGLE_SUCCESS       رճɹ
*/
DWORD WINAPI Dongle_Close(DONGLE_HANDLE hDongle);

/**
* @brief  Ȩ޼ɲ
*
* @param  hDongle          [in]      򿪵ļ
* @param  nLen             [in]      ҪĳȡnLenȡֵΧΪ 1~128
* @param  pRandom          [out]     
*
* @return DONGLE_SUCCESS             ȡɹ
*/
DWORD WINAPI Dongle_GenRandom(DONGLE_HANDLE hDongle, int nLen, BYTE * pRandom);

/**
* @brief  LEDƵĿƲȨ޼ɲ
*
* @param  hDongle     [in]     򿪵ļ
* @param  nFlag       [in]     ͡磺nFlag = LED_ONʾLEDΪ״̬
*                              nFlag = LED_OFFʾLEDΪ״̬nFlag = LED_BLINK
*                              ʾLEDΪ˸״̬
*
* @return DONGLE_SUCCESS       ִгɹ
*/
DWORD WINAPI Dongle_LEDControl(DONGLE_HANDLE hDongle, int nFlag);

/**
* @brief  ȡڵļļĶȡȨȡڴʱ趨
*
* @param  hDongle      [in]         򿪵ļ
* @param  wFileID      [in]         ļID
* @param  wOffset      [in]         ļƫ
* @param  pOutData     [in]         ݻ
* @param  nDataLen     [out]        pOutDataĳȡȡ󳤶Ȳܳ1024ֽ
*
* @return DONGLE_SUCCESS            ȡļɹ  
*/
DWORD WINAPI Dongle_ReadFile(DONGLE_HANDLE hDongle, WORD wFileID, WORD wOffset, BYTE* pOutData, int nDataLen);


/**
* @brief  У
*
* @param  hDongle		   [in]       򿪵ļ
* @param  nFlags           [in]       PIN͡ȡֵΪFLAG_USERPINFLAG_ADMINPIN
* @param  pPIN             [in]       PIN롣
* @param  pRemainCount     [out]      ʣԴ0ʾ1~253ʾʣ255ʾԴ
*
* @return DONGLE_SUCCESS              УɹУʧܣķֵҲʣԴ
*                                     ( & 0xFFFFFF00) == DONGLE_INCORRECT_PINλʾʣ
*/
DWORD WINAPI Dongle_VerifyPin(DONGLE_HANDLE hDongle, int nFlags, char* pPIN, int* pRemainCount);

/**
* @brief  ȡݡС8kǰ4k(0~4095)ĶдûȨƣ4k(4096~8191)Ȩ޿ɶ
*         ֻпȨ޿д
* 
* @param  hDongle      [in]      򿪵ļ
* @param  nOffset      [in]      ʼƫơΧ0~8191
* @param  pData        [out]     ȡݻ
* @param  nDataLen     [in]      pDataĻСܳ1024ֽ
*
* @return  DONGLE_SUCCESS        ȡݳɹ 
*/
DWORD WINAPI Dongle_ReadData(DONGLE_HANDLE hDongle, int nOffset, BYTE* pData, int nDataLen);

/**
* @brief  дݡС8kǰ4k(0~4095)ĶдûȨƣ4k(4096~8191)Ȩ޿ɶ
*         ֻпȨ޿д
* 
* @param  hDongle      [in]      򿪵ļ
* @param  nOffset      [in]      ʼƫơΧ0~8191
* @param  pData        [in]      дݻ
* @param  nDataLen     [in]      pDataĻСܳ1024ֽ
*
* @return  DONGLE_SUCCESS        дݳɹ 
*/
DWORD WINAPI Dongle_WriteData(DONGLE_HANDLE hDongle, int nOffset, BYTE* pData, int nDataLen);

/**
* @brief  RSA˽Կ㡣ʹȨȡRSA˽ԿļȨޣRSA˽Կļʱ趨˵
*         1.ڼ,ݳȱС˽ԿIDΪwPriFileIDԿȼȥ11,Աںڲpadding
*         2.ڽ,ݳȱwPriFileIDָʾԿһ(1024λԿʱΪ1282048ʱΪ256)
*         3.ʱڲpaddingʽΪ:PKCS1_TYPE_1 (ڶֽΪ0x01,0XFF)   
*
* @param  hDongle         [in]         򿪵ļ
* @param  wPriFileID      [in]         RSA˽ԿļID
* @param  nFlag           [in]         ͡磬FLAG_ENCODEʾ㣻FLAG_DECODEʾ㡣
* @param  pInData         [in]         ݡ
* @param  nInDataLen      [in]         pInDataĴС
* @param  pOutData        [out]        ݻ
* @param  pOutDataLen     [in,out]     pOutDataĴСͷصݴС
*
* @return DONGLE_SUCCESS               RSA˽Կɹ 
*/
DWORD WINAPI Dongle_RsaPri(DONGLE_HANDLE hDongle, WORD wPriFileID, int nFlag, BYTE* pInData, int nInDataLen, BYTE* pOutData, int* pOutDataLen);

/**
* @brief  RSAԿ㡣Ȩ޿ɵá˵
*         1.ڼ,ݳȱСpPubKeyָʾԿ-11,Աںڲpadding
*         2.ڽ,ݳȱpPubKeyָʾԿһ(1024λԿʱΪ1282048ʱΪ256)
*         3.ʱڲpaddingʽΪ:PKCS1_TYPE_2 (ڶֽΪ0x02,)  
*
* @param  hDongle         [in]         򿪵ļ
* @param  nFlag           [in]         ͡磬FLAG_ENCODEʾ㣻FLAG_DECODEʾ㡣
* @param  pPubKey         [in]         RSAԿݡԴRSA˽ԿʱĹԿݡ
* @param  pInData         [in]         ݡ
* @param  nInDataLen      [in]         pInDataĴС
* @param  pOutData        [out]        ݻ
* @param  pOutDataLen     [in,out]     pOutDataĴСͷصݴС
*
* @return DONGLE_SUCCESS               RSAԿɹ
*/
DWORD WINAPI Dongle_RsaPub(DONGLE_HANDLE hDongle, int nFlag, RSA_PUBLIC_KEY* pPubKey, BYTE* pInData, int nInDataLen, BYTE* pOutData, int* pOutDataLen);

/**
* @brief  ECC˽ԿǩʹȨȡECC˽ԿļȨޣECC˽Կļʱ趨˵
*         1.ǩ㷨Ϊ: ECDSA_Sign
*         2.HashֵĳECC˽ԿԿй(Կ192λ,hashֵȲܳ24(192/8 = 24)ֽ)
*                                                    (Կ256λ,hashֵȲܳ32(256/8 = 32)ֽ)
*         3.߲Ϊ:EC_NIST_PRIME_192EC_NIST_PRIME_256
*
* @param  hDongle          [in]      򿪵ļ
* @param  wPriFileID       [in]      ECC˽ԿļID
* @param  pHashData        [in]      Hashݡ
* @param  nHashDataLen     [in]      pHashDataĴС
* @param  pOutData         [out]     ǩݡС̶Ϊ64ֽ(256λECCʱ,192λECCʱλᲹ0)
*
* @return DONGLE_SUCCESS             ʾǩɹ
*/
DWORD WINAPI Dongle_EccSign(DONGLE_HANDLE hDongle, WORD wPriFileID, BYTE* pHashData, int nHashDataLen, BYTE* pOutData);


/**
* @brief  ECCԿǩʹȨȡECC˽ԿļȨޣECC˽Կļʱ趨˵
*         1.ǩ㷨Ϊ: ECDSA_Verify
*         2.HashֵĳECC˽ԿԿй(Կ192λ,hashֵȲܳ24(192/8 = 24)ֽ)
*                                                    (Կ256λ,hashֵȲܳ32(256/8 = 32)ֽ)
*         3.߲Ϊ:EC_NIST_PRIME_192EC_NIST_PRIME_256
*
* @param  hDongle          [in]      򿪵ļ
* @param  pPubKey          [in]      ECCԿݡ
* @param  pHashData        [in]      Hashݡ
* @param  nHashDataLen     [in]      pHashDataĴС
* @param  pSign            [in]      ǩݡС̶Ϊ64ֽڣΪDongle_EccSignصpOutDataݡ
*
* @return DONGLE_SUCCESS             ʾǩɹ,ʾǩʧܡ
*/
DWORD WINAPI Dongle_EccVerify(DONGLE_HANDLE hDongle, ECCSM2_PUBLIC_KEY* pPubKey, BYTE* pHashData, int nHashDataLen, BYTE* pSign);

/**
* @brief  3DESӽܡȨ޼, ȨȡԿļȨޡ
* 
* @param  hDongle        [in]      򿪵ļ
* @param  wKeyFileID     [in]      ԿļID
* @param  nFlag          [in]      ͡磬FLAG_ENCODEʾ㣻FLAG_DECODEʾ㡣
* @param  pInData        [in]      ݻ
* @param  pOutData       [out]     ݻСҪݻͬݻΪͬһ
* @param  nDataLen       [in]      pInDataݴСݳȱ16,ֵ1024
*
* @return DONGLE_SUCCESS           3DESܻɹ
*/
DWORD WINAPI Dongle_TDES(DONGLE_HANDLE hDongle, WORD wKeyFileID, int nFlag, BYTE* pInData, BYTE* pOutData, int nDataLen);

/**
* @brief  㷨Ȩ޿ʹ, ̿ÿ
*         1.㷨PIDйأ(PID=FFFFFFFF)ܽ㡣
*         2.ڲΪ-1ݼ0˺ʹá
*
* @param  hDongle        [in]      򿪵ļ
* @param  pSeed          [in]      ݡ 
* @param  nSeedLen       [in]      볤ȡȡֵΧΪ1~250ֽڡ
* @param  pOutData       [out]     ݻĴС̶Ϊ16ֽڡ
*
* @return DONGLE_SUCCESS           ɹ
*/
DWORD WINAPI Dongle_Seed(DONGLE_HANDLE hDongle, BYTE* pSeed, int nSeedLen, BYTE* pOutData);

/**
* @brief  ȡUTCʱ䡣
* 
* @param  hDongle     [in]     򿪵ļ
* @param  pdwUTCTime  [in]     ʱֵ
*
* @return DONGLE_SUCCESS       üʱɹ
*/
DWORD WINAPI Dongle_GetUTCTime(DONGLE_HANDLE hDongle, DWORD * pdwUTCTime);

/** 
* @brief  ȡʱ䡣Ȩ޻ȡ
*
* @param  hDongle     [in]      򿪵ļ
* @param  pdwTime     [out]     ȡĵUTCʱֵ
*                               *pdwTime = 0XFFFFFFFFʾƵʱ
*                               (*pdwTime & 0XFFFF0000) == 0ֵʾʣ༸Сʱ
*                               (*pdwTime & 0XFFFF0000) != 0ֵʾڵUTCʱ䣬ͨgmtimeȽֵת
*
* @return DONGLE_SUCCESS        ȡʱɹ
*/
DWORD WINAPI Dongle_GetDeadline(DONGLE_HANDLE hDongle, DWORD * pdwTime);

/**
 * @brief  ָڿִгпִļȨޣȡʱÿִļã
 *         EXE_FILE_INFOеm_Privݵ󳤶Ȳܳ1024ֽڣݻ
 *         pInOutBufӦڵInOutBuf
 *
 * @param  hDongle            [in]             򿪵ļ
 * @param  wFileID            [in]             ִļļID
 * @param  pInOutBuf          [in,out]         ݻ
 * @param  wInOutBufLen       [in]             ݻpInOutBufĴС                                           
 * @param  pMainRet           [out]            ڿִгmainķֵΪNULL
 *
 * @return DONGLE_SUCCESS                  ָĿִļɹ
 */
DWORD WINAPI Dongle_RunExeFile(DONGLE_HANDLE hDongle, WORD wFileID, BYTE * pInOutBuf, WORD wInOutBufLen, int * pMainRet);

#ifdef __cplusplus
}
#endif

#endif