﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Runtime.InteropServices;

/// <summary>
///Common 的摘要说明
/// </summary>
public class Common
{
	public Common()
	{
		//
		//TODO: 在此处添加构造函数逻辑
		//
	}

    public static int i2a(int i)
    {
        if (i >= 0 && i <= 9)
        {
            i += 48;
        }

        if (i >= 10 && i <= 16)
        {
            i -= 10;
            i += 65;
        }

        return i;
    }
    public static string Bytes2String(byte[] bytes)
    {
        //string str = System.Text.Encoding.Default.GetString(bytes);
        int nLen = bytes.Length * 2;
        string str = null;
        char[] ch = new char[nLen];
        for (int i = 0; i < bytes.Length; i++)
        {
            int tmp = bytes[i];
            int a = tmp >> 4; //high
            int b = tmp & 0x0F; //low

            a = i2a(a);
            b = i2a(b);

            ch[i * 2] = (char)a;
            ch[i * 2 + 1] = (char)b;
        }

        str = new string(ch);

        return str;
    }

    public static byte[] String2Bytes(string str)
    {
        int i = 0;
        byte[] bytes = System.Text.Encoding.ASCII.GetBytes(str);

        for (i = 0; i < bytes.Length; i++)
        {
            if (bytes[i] >= '0' && bytes[i] <= '9')
            {
                bytes[i] -= 48;
            }

            if (bytes[i] >= 'a' && bytes[i] <= 'f')
            {
                bytes[i] -= 97;
                bytes[i] += 10;
            }

            if (bytes[i] >= 'A' && bytes[i] <= 'F')
            {
                bytes[i] -= 65;
                bytes[i] += 10;
            }
        }
        int nLen = bytes.Length / 2;
        byte[] data = new byte[nLen];
        int tmp = 0;

        i = 0;
        for (int j = 0; j < bytes.Length; j += 2)
        {
            int a = bytes[j];
            int b = bytes[j + 1];
            tmp = a << 4;
            tmp = tmp | b;

            data[i] = (byte)tmp;

            i++;
        }

        return data;
    }

    /// <summary>
    /// 结构体转数组
    /// </summary>
    /// <param name="structObj">结构体对象</param>
    /// <returns>数组</returns>
    public static byte[] StructToBytes(object structObj)
    {
        //得到结构体的大小
        int size = Marshal.SizeOf(structObj);
        //创建byte数组
        byte[] bytes = new byte[size];
        //分配结构体大小的内存空间
        IntPtr structPtr = Marshal.AllocHGlobal(size);
        //将结构体拷到分配好的内存空间
        Marshal.StructureToPtr(structObj, structPtr, false);
        //从内存空间拷到byte数组
        Marshal.Copy(structPtr, bytes, 0, size);
        //释放内存空间
        Marshal.FreeHGlobal(structPtr);
        //返回byte数组
        return bytes;
    }
    
    /// <summary>
    /// byte数组转结构体
    /// </summary>
    /// <param name="bytes">byte数组</param>
    /// <param name="type">结构体类型</param>
    /// <returns>转换后的结构体</returns>
    public static object BytesToStuct(byte[] bytes, Type type)
    {
        //得到结构体的大小
        int size = Marshal.SizeOf(type);
        //byte数组长度小于结构体的大小
        if (size > bytes.Length)
        {
            //返回空
            return null;
        }
        //分配结构体大小的内存空间
        IntPtr structPtr = Marshal.AllocHGlobal(size);
        //将byte数组拷到分配好的内存空间
        Marshal.Copy(bytes, 0, structPtr, size);
        //将内存空间转换为目标结构体
        object obj = Marshal.PtrToStructure(structPtr, type);
        //释放内存空间
        Marshal.FreeHGlobal(structPtr);
        //返回结构体
        return obj;
    }


}